#include <Windows.h>
#include <atlbase.h>
#include <streams.h>

#include "MemoryRendererInputPin.h"
#include "MemoryRendererAllocator.h"

// RXgN^
MemoryRendererInputPin::MemoryRendererInputPin( MemoryRenderer* pRenderer, CCritSec* pInterfaceLock, HRESULT* phr, LPCWSTR name )
	: CRendererInputPin( (CBaseRenderer*) pRenderer, phr, name )
	, m_pInterfaceLock( pInterfaceLock )
	, m_pGrabAllocator(new MemoryRendererAllocator( NAME( "Allocator" ), NULL, phr ) )
	, m_activeGrabAllocator( FALSE )
{
}

// ÕAP[^IuWFNg蓖ĂB
STDMETHODIMP MemoryRendererInputPin::GetAllocator( IMemAllocator** ppAllocator )
{
	CAutoLock cInterfaceLock( m_pInterfaceLock );
	CheckPointer( ppAllocator, E_POINTER );

	// CBaseInputPin::m_pAllocator ɃAP[^܂ݒ肳ĂȂƂ͐ݒ肷B
	if( m_pAllocator == NULL )
	{
		m_pAllocator = m_pGrabAllocator;
		m_pAllocator->AddRef();
	}

	m_pAllocator->AddRef();		// QƃJEgĉ̓C^tF[X̎dl炵B
	*ppAllocator = m_pAllocator;
	
	return S_OK;
}

// AP[^܂ƂɌĂяoB
// pAllocator cc ̐ڑŎgpAP[^B
// bReadOnly  cc ̃AP[^̃Tvǂ݂ƂpȂTRUEB
STDMETHODIMP MemoryRendererInputPin::NotifyAllocator( IMemAllocator* pAllocator, BOOL bReadOnly )
{
	CAutoLock cInterfaceLock( m_pInterfaceLock );

	// NXĂяo
    HRESULT hr = CBaseInputPin::NotifyAllocator( pAllocator, bReadOnly );
    if( FAILED( hr ) )
        return hr;

	//ÕAP[^LǂL^B
	m_activeGrabAllocator = ( pAllocator == m_pGrabAllocator );

	return S_OK;
}
